#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QGridLayout>
#include <QPushButton>
#include <QtWidgets/QApplication>
#include <QtWidgets/QLineEdit>
#include <QtWidgets/QRadioButton>

class Calculator : public QWidget
{
    Q_OBJECT

public:

    explicit Calculator(QWidget *parent = 0);
    ~Calculator() = default;

    bool OnlyDigits();
    void SetDigits(bool);
    bool OneDot(bool);

private slots:

    void SwitchMode();
    void NumberClicked();
    void UnaryOpClicked();
    void BinaryOpClicked();
    void DotClicked();
    void Clear();
    void Equal();

private:

    QWidget* mDefaultCalculatorWidget;
    QWidget* mSimpleCalculatorWidget;
    QWidget* mEngineeringCalcWidget;

    QGridLayout* mDefaultCalculatorLayout;
    QGridLayout* mSimpleCalculatorLayout;
    QGridLayout* mEngineeringCalcLayout;
    QGridLayout* mMainLayout;

    QRadioButton* mSimpleModeRadioButton;
    QRadioButton* mEngineeringModeRadioButton;
    QLineEdit* mLineEdit;

    bool mDigitsOonly = true;
    bool mDotOne = false;

    void createDefaultCalcWidget();
    void createSimpleCalcWidget();
    void createEngineeringCalcWidget();

    void createSimpleCalc();
    void createEngineeringCalc();

    double fact(double);
};

#endif // MAINWINDOW_H
